"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var JENKINS_JOB_NAME_ENV = "JOB_NAME"; //Name of the project of this build. This is the name you gave your job when you first set it up. It's the third column of the Jenkins Dashboard main page.
var JENKINS_JOB_ID_ENV = "BUILD_ID"; //The current build id, such as "2005-08-22_23-59-59" (YYYY-MM-DD_hh-mm-ss, defunct since version 1.597)
var JENKINS_JOB_URL_ENV = "BUILD_URL"; //The URL where the results of this build can be found (e.g. http://buildserver/jenkins/job/MyJobName/666/)
//For detailed information on Jenkins env vars, see https://wiki.jenkins.io/display/JENKINS/Building+a+software+project
var CiInfoBuilder = /** @class */ (function () {
    function CiInfoBuilder() {
        this.info = {};
    }
    CiInfoBuilder.prototype.fillData = function () {
        if (this.isJenkins()) {
            this.info.jobId = process.env[JENKINS_JOB_ID_ENV];
            this.info.jobName = process.env[JENKINS_JOB_NAME_ENV];
            this.info.jobUrl = process.env[JENKINS_JOB_URL_ENV];
        }
    };
    CiInfoBuilder.prototype.isJenkins = function () {
        return process.env[JENKINS_JOB_ID_ENV] &&
            process.env[JENKINS_JOB_NAME_ENV] &&
            process.env[JENKINS_JOB_URL_ENV];
    };
    CiInfoBuilder.prototype.build = function () {
        this.fillData();
        return this.info;
    };
    return CiInfoBuilder;
}());
exports.CiInfoBuilder = CiInfoBuilder;
//# sourceMappingURL=ci-info-builder.js.map