"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var agent_events_controller_1 = require("./agent-events-controller");
var console_logger_1 = require("../console-logger");
/**
 * A class with static methods for sending notification to cockpit.
 * Using this class enables to avoid passing instance of AgentEventsController for each class
 */
var CockpitNotifier = /** @class */ (function () {
    function CockpitNotifier() {
    }
    CockpitNotifier.notifyStart = function (agentConfig, agentInstanceData, sendsPing, logger, packageJsonFile, backendProxy) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        CockpitNotifier.controller = new agent_events_controller_1.AgentEventsController(agentConfig, agentInstanceData, sendsPing, logger, backendProxy);
                        return [4 /*yield*/, CockpitNotifier.controller.submitAgentStartedEvent(packageJsonFile)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CockpitNotifier.notifyShutdown = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        CockpitNotifier.verifyControllerInitialized();
                        return [4 /*yield*/, CockpitNotifier.controller.submitAgentShutdownEvent()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    CockpitNotifier.sendGenericMessage = function (message) {
        CockpitNotifier.verifyControllerInitialized();
        CockpitNotifier.controller.submitGenericMessage(message);
    };
    CockpitNotifier.sendWarning = function (message) {
        CockpitNotifier.verifyControllerInitialized();
        CockpitNotifier.controller.submitWarning(message);
    };
    CockpitNotifier.logSkippedNotification = function () {
        if (!CockpitNotifier.controllerNullLogged) {
            console_logger_1.consoleLogger.warn("'AgentEventController' dose not instantiated, skipping cockpit notification");
            CockpitNotifier.controllerNullLogged = true;
        }
    };
    CockpitNotifier.verifyControllerInitialized = function () {
        if (!CockpitNotifier.controller) {
            throw new Error("'Agent started' event does not sent. Disabling");
        }
    };
    // Added for tests
    CockpitNotifier.reset = function () {
        CockpitNotifier.controller = undefined;
        CockpitNotifier.controllerNullLogged = false;
    };
    CockpitNotifier.controllerNullLogged = false;
    return CockpitNotifier;
}());
exports.CockpitNotifier = CockpitNotifier;
//# sourceMappingURL=cockpit-notifier.js.map