"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var http_client_1 = require("./http-client");
var sl_routes_1 = require("./sl-routes");
var validation_utils_1 = require("../utils/validation-utils");
var entities_mapper_1 = require("./entities-mapper");
var constants_1 = require("../constants/constants");
var sl_env_vars_1 = require("../constants/sl-env-vars");
var timer_utils_1 = require("../utils/timer-utils");
var BackendProxy = /** @class */ (function () {
    // TODO: get httpClient in constructor always
    function BackendProxy(agentInstanceData, config, logger, httpClient) {
        this.agentInstanceData = agentInstanceData;
        this.config = config;
        this.logger = logger;
        this.client = httpClient || new http_client_1.HttpClient(this.config, this.logger);
    }
    BackendProxy.prototype.getBuildSession = function (buildSessionId, callback) {
        var _this = this;
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(buildSessionId, constants_1.Constants.BUILD_SESSION_ID);
        var url = sl_routes_1.SLRoutes.buildSessionV2(buildSessionId);
        this.client.get(url, function (err, body) {
            _this.invokeCallback(callback, err, body);
        });
    };
    BackendProxy.prototype.createBuildSessionId = function (request, callback) {
        var _this = this;
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(request, constants_1.Constants.REQUEST);
        var url = sl_routes_1.SLRoutes.buildSessionV2();
        this.client.post(request, url, function (err, body) {
            _this.invokeCallback(callback, err, body, entities_mapper_1.EntitiesMapper.toCreateBuildSessionIdResponse);
        });
    };
    BackendProxy.prototype.createBuildSessionIdPromise = function (request) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            var _this = this;
            return __generator(this, function (_a) {
                validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(request, constants_1.Constants.REQUEST);
                url = constants_1.Constants.PULL_REQUEST_PARAMS in request ? sl_routes_1.SLRoutes.prBuildSession() : sl_routes_1.SLRoutes.buildSessionV2();
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.client.post(request, url, function (err, body) {
                            if (err) {
                                return reject(err);
                            }
                            return resolve(body);
                        });
                    })];
            });
        });
    };
    BackendProxy.prototype.getRecommendedVersion = function (request) {
        var _this = this;
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(request, constants_1.Constants.REQUEST);
        var url = sl_routes_1.SLRoutes.recommendedAgentV2(request.componentName, request.customerId, request.appName, request.branchName, request.testStage);
        return new Promise(function (resolve, reject) {
            _this.client.get(url, function (err, body) {
                if (err) {
                    return reject(err);
                }
                else if (body && body.agent && body.agent) {
                    return resolve(body.agent);
                }
                else {
                    return reject(new Error("Failed to get recommended version due to unexpected response from the server."));
                }
            });
        });
    };
    BackendProxy.prototype.submitBuildMapping = function (request) {
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(request, constants_1.Constants.REQUEST);
        var url = sl_routes_1.SLRoutes.buildMappingV4();
        return this.submitPostRequestWithRetries(request, url);
    };
    BackendProxy.prototype.submitLogs = function (request, callback) {
        var _this = this;
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(request, constants_1.Constants.REQUEST);
        var url = sl_routes_1.SLRoutes.logSubmissionV2();
        this.client.post(request, url, function (err, body) {
            _this.invokeCallback(callback, err, body);
        });
    };
    BackendProxy.prototype.getRemoteConfig = function (request, callback) {
        var _this = this;
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(request, constants_1.Constants.REQUEST);
        var url = sl_routes_1.SLRoutes.configV3(this.agentInstanceData, request.appName, request.branch, request.build, request.testStage, request.labId);
        this.client.get(url, function (err, body) {
            _this.invokeCallback(callback, err, body);
        });
    };
    BackendProxy.prototype.startExecution = function (request, callback) {
        var _this = this;
        var url = sl_routes_1.SLRoutes.testExecution();
        this.client.post(request, url, function (err, body) {
            _this.invokeCallback(callback, err, body);
        });
    };
    BackendProxy.prototype.uploadReport = function (request, callback) {
        var _this = this;
        var url = sl_routes_1.SLRoutes.externalData();
        this.client.postMultipart(request, url, function (err, body) {
            _this.invokeCallback(callback, err, body);
        });
    };
    BackendProxy.prototype.externalReport = function (request, callback) {
        var _this = this;
        var url = sl_routes_1.SLRoutes.externalReport();
        this.client.post(request, url, function (err, body) {
            _this.invokeCallback(callback, err, body);
        });
    };
    BackendProxy.prototype.endExecution = function (request, callback) {
        var _this = this;
        var url = sl_routes_1.SLRoutes.endExecution(request.customerId, request.appName, request.buildName, request.branchName, request.environment);
        this.client.delete(null, url, function (err, body) {
            _this.invokeCallback(callback, err, body);
        });
    };
    BackendProxy.prototype.submitEvents = function (packetToSend, callback, async) {
        if (async === void 0) { async = true; }
        var url = sl_routes_1.SLRoutes.eventsV2();
        this.client.post(packetToSend, url, callback);
    };
    BackendProxy.prototype.submitEventsPromise = function (packetToSend) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var url = sl_routes_1.SLRoutes.eventsV2();
            _this.client.post(packetToSend, url, function (err) {
                if (err) {
                    reject(err);
                }
                resolve();
            });
        });
    };
    BackendProxy.prototype.submitBlob = function (body, buildSessionId, blobId, callback) {
        var url = sl_routes_1.SLRoutes.blobs(buildSessionId, blobId);
        this.client.post(body, url, callback, true, "application/octet-stream");
    };
    BackendProxy.prototype.submitAgentEvent = function (body) {
        var _this = this;
        var url = sl_routes_1.SLRoutes.agentEvents();
        return new Promise(function (resolve, reject) {
            _this.client.post(body, url, function (error, response) {
                if (error) {
                    return reject(error);
                }
                return resolve();
            });
        });
    };
    BackendProxy.prototype.getTestsRecommendation = function (buildSessionId, stage) {
        var url = sl_routes_1.SLRoutes.testsRecommendations(buildSessionId, stage);
        return this.submitGetRequestWithRetries(url, null, null, [400, 404], false);
    };
    BackendProxy.prototype.addOrUpdateIntegrationBuildComponents = function (buildSessionId, components, agentId) {
        var url = sl_routes_1.SLRoutes.integrationBuildComponents(buildSessionId);
        return this.submitPutRequestWithRetries({ components: components, agentId: agentId }, url);
    };
    BackendProxy.prototype.deleteIntegrationBuildComponents = function (buildSessionId, components, agentId) {
        var url = sl_routes_1.SLRoutes.integrationBuildComponents(buildSessionId);
        return this.submitDelRequestWithRetries({ components: components, agentId: agentId }, url);
    };
    BackendProxy.prototype.buildEnd = function (data) {
        return this.submitPostRequestWithRetries(data, sl_routes_1.SLRoutes.buildEnd());
    };
    BackendProxy.prototype.invokeCallback = function (callback, err, body, map) {
        validation_utils_1.ValidationUtils.verifyNotNullOrEmpty(callback, constants_1.Constants.CALLBACK);
        if (err != null) {
            return callback(err, body);
        }
        if (map == null) {
            return callback(null, body);
        }
        var apiResponse = map(body);
        return callback(null, apiResponse);
    };
    BackendProxy.prototype.submitPostRequestWithRetries = function (body, url, retries, delayBetweenRetires) {
        var _this = this;
        return this.makeRequestWithRetries(function (callback) { _this.client.post(body, url, callback); }, retries, delayBetweenRetires);
    };
    BackendProxy.prototype.submitPutRequestWithRetries = function (body, url, retries, delayBetweenRetires) {
        var _this = this;
        return this.makeRequestWithRetries(function (callback) { _this.client.put(body, url, callback); }, retries, delayBetweenRetires);
    };
    BackendProxy.prototype.submitDelRequestWithRetries = function (body, url, retries, delayBetweenRetires) {
        var _this = this;
        return this.makeRequestWithRetries(function (callback) { _this.client.delete(body, url, callback); }, retries, delayBetweenRetires);
    };
    BackendProxy.prototype.submitGetRequestWithRetries = function (url, retries, delayBetweenRetires, statusesForRetry, isNotFoundAcceptable) {
        var _this = this;
        if (isNotFoundAcceptable === void 0) { isNotFoundAcceptable = true; }
        return this.makeRequestWithRetries(function (callback) { _this.client.get(url, callback, isNotFoundAcceptable); }, retries, delayBetweenRetires, statusesForRetry);
    };
    BackendProxy.prototype.makeRequestWithRetries = function (doSingleRequest, retries, delayBetweenRetires, statusesForRetry) {
        return __awaiter(this, void 0, void 0, function () {
            var retriesLeft, intervalBetweenRetries, lastError, bodyAndStatusCode, errAndStatusCode_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        retriesLeft = retries || sl_env_vars_1.SlEnvVars.getHttpMaxAttempts() || BackendProxy.DEFAULT_HTTP_MAX_ATTEMPTS;
                        intervalBetweenRetries = delayBetweenRetires || sl_env_vars_1.SlEnvVars.getHttpAttemptInterval() || BackendProxy.DEFAULT_HTTP_ATTEMPT_INTERVAL;
                        lastError = undefined;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        retriesLeft--;
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                doSingleRequest(function (err, body, statusCode) {
                                    err ? reject({ err: err, statusCode: statusCode }) : resolve({ body: body, statusCode: statusCode }); //Always return status code
                                });
                            })];
                    case 2:
                        bodyAndStatusCode = _a.sent();
                        return [2 /*return*/, bodyAndStatusCode.body];
                    case 3:
                        errAndStatusCode_1 = _a.sent();
                        this.logger.info(errAndStatusCode_1);
                        lastError = errAndStatusCode_1.err;
                        if (!this.shouldRetryRequest(errAndStatusCode_1.statusCode, statusesForRetry)) {
                            return [3 /*break*/, 7]; //Non-retriable error, break do..while loop and
                        }
                        return [3 /*break*/, 4];
                    case 4: return [4 /*yield*/, timer_utils_1.TimerUtils.sleep(intervalBetweenRetries)];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6:
                        if (retriesLeft > 0) return [3 /*break*/, 1];
                        _a.label = 7;
                    case 7: throw lastError;
                }
            });
        });
    };
    BackendProxy.prototype.shouldRetryRequest = function (statusCode, statusesForRetry) {
        if (statusesForRetry === void 0) { statusesForRetry = []; }
        if (statusCode >= 500 || statusCode && statusesForRetry.includes(statusCode))
            return true;
        return false;
    };
    BackendProxy.DEFAULT_HTTP_MAX_ATTEMPTS = 6;
    BackendProxy.DEFAULT_HTTP_ATTEMPT_INTERVAL = 5 * 1000;
    return BackendProxy;
}());
exports.BackendProxy = BackendProxy;
//# sourceMappingURL=backend-proxy.js.map