interface IBuildSessionParams {
    appName: string;
    buildName: string;
    branchName: string;
    customerId: string;
}
/**
 * A proxy for interacting sealights mock server using promises
 */
export declare class MockServerProxy {
    static getAllFootprints(): Promise<any[]>;
    static setRecommendedVersion(requestParams: any): Promise<void>;
    static createBuildSessionId(buildSessionParams: IBuildSessionParams): Promise<string>;
    static getBuildMapping(): Promise<any[]>;
    static resetState(): Promise<void>;
    static getToken(): Promise<string>;
    static getAllEvents(): Promise<any>;
    static getAllAgentEvents(): Promise<any>;
    static getAllLogs(): Promise<any>;
    static setDelay(duration_ms: number, requestToBeDelayed: string): Promise<any>;
    static setEnabled(enabled: boolean): Promise<any>;
    private static executeRequest;
}
export {};
