"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("request");
var HttpVerb;
(function (HttpVerb) {
    HttpVerb["GET"] = "GET";
    HttpVerb["POST"] = "POST";
    HttpVerb["DELETE"] = "DELETE";
    HttpVerb["PUT"] = "PUT";
})(HttpVerb || (HttpVerb = {}));
var MockServerRoutes;
(function (MockServerRoutes) {
    MockServerRoutes["SERVER_URL"] = "http://localhost:9900";
    MockServerRoutes["GET_ALL_FOOTPRINTS"] = "/api/test/footprints";
    MockServerRoutes["GET_ALL_EVENTS"] = "/api/test/agents/events";
    MockServerRoutes["GET_ALL_AGENT_EVENTS"] = "/api/test/v3/agents/agent-events";
    MockServerRoutes["GET_ALL_LOGS"] = "/api/test/logs";
    MockServerRoutes["GET_BUILD_MAPPING"] = "/api/test/buildmapping";
    MockServerRoutes["RESET"] = "/api/test/reset";
    MockServerRoutes["GET_TOKEN"] = "/api/test/token";
    MockServerRoutes["CREATE_BUILDSESSION_ID"] = "/api/v2/agents/buildsession";
    MockServerRoutes["SET_RECOMMENDED_VERSION"] = "/api/test/recommended";
    MockServerRoutes["SET_DELAY"] = "/api/test/setDelay";
    MockServerRoutes["SET_ENABLED"] = "/api/test/setEnabled";
})(MockServerRoutes || (MockServerRoutes = {}));
/**
 * A proxy for interacting sealights mock server using promises
 */
var MockServerProxy = /** @class */ (function () {
    function MockServerProxy() {
    }
    MockServerProxy.getAllFootprints = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.executeRequest(MockServerRoutes.GET_ALL_FOOTPRINTS, HttpVerb.GET)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    MockServerProxy.setRecommendedVersion = function (requestParams) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeRequest(MockServerRoutes.SET_RECOMMENDED_VERSION, HttpVerb.POST, null, requestParams)];
            });
        });
    };
    MockServerProxy.createBuildSessionId = function (buildSessionParams) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeRequest(MockServerRoutes.CREATE_BUILDSESSION_ID, HttpVerb.POST, false, buildSessionParams)];
            });
        });
    };
    MockServerProxy.getBuildMapping = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.executeRequest(MockServerRoutes.GET_BUILD_MAPPING, HttpVerb.GET)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    MockServerProxy.resetState = function () {
        return this.executeRequest(MockServerRoutes.RESET, HttpVerb.GET, false);
    };
    MockServerProxy.getToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.executeRequest(MockServerRoutes.GET_TOKEN, HttpVerb.GET, false)];
            });
        });
    };
    MockServerProxy.getAllEvents = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.executeRequest(MockServerRoutes.GET_ALL_EVENTS, HttpVerb.GET)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    MockServerProxy.getAllAgentEvents = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.executeRequest(MockServerRoutes.GET_ALL_AGENT_EVENTS, HttpVerb.GET)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    MockServerProxy.getAllLogs = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.executeRequest(MockServerRoutes.GET_ALL_LOGS, HttpVerb.GET)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    MockServerProxy.setDelay = function (duration_ms, requestToBeDelayed) {
        var requestData = { duration_ms: duration_ms, requestToBeDelayed: requestToBeDelayed };
        return this.executeRequest(MockServerRoutes.SET_DELAY, HttpVerb.POST, null, requestData);
    };
    MockServerProxy.setEnabled = function (enabled) {
        var requestData = { enabled: enabled };
        return this.executeRequest(MockServerRoutes.SET_ENABLED, HttpVerb.POST, null, requestData);
    };
    MockServerProxy.executeRequest = function (uri, verb, shouldParse, requestData) {
        if (shouldParse === void 0) { shouldParse = true; }
        return new Promise(function (resolve, reject) {
            var url = MockServerRoutes.SERVER_URL + uri;
            var options = {
                url: url,
                method: verb,
                headers: {
                    "content-type": "application/json",
                },
                json: requestData
            };
            request(options, function (err, resp, body) {
                if (err) {
                    reject(err);
                }
                if (resp.statusCode > 299) {
                    reject(new Error("Unexpected status code received: " + resp.statusCode));
                }
                if (shouldParse) {
                    try {
                        var parsedResponse = JSON.parse(body);
                        resolve(parsedResponse);
                    }
                    catch (err) {
                        reject(err);
                    }
                }
                resolve(body);
            });
        });
    };
    return MockServerProxy;
}());
exports.MockServerProxy = MockServerProxy;
//# sourceMappingURL=mock-server-proxy.js.map